#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n;
	long long R;
	
	cin >> n >> R;
	
	vector <long long> a(n + 1), pr(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		pr[i] = pr[i - 1] + a[i];
	}
	
	for (int i = 1; i <= n; i++) {
		if (a[i] > R) {
			cout << "-1\n";
			continue;
		}
		
		int l = 0, r = max(i - 1, n - i) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			int sl = max(1, i - m), sr = min(n, i + m);
			if (pr[sr] - pr[sl] <= R)
				l = m;
			else
				r = m;
		}
		
		cout << l << '\n';
	}
	
	return 0;
}