#include "testlib.h"
#include <string>
#include <vector>

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	
	inf.maxMessageLength = 2'000'000;
	int n = inf.readInt(1, 100'000, "n");
	inf.readEoln();
	int sm = 0;
	std::vector <std::string> s = inf.readWords(n, "[a-z]{1,1000000}", "sentence");
	inf.readEoln();
	for (int i = 0; i < n; i++)
		sm += s[i].length();
	
	ensuref(sm <= 1'000'000, "sum length exceeds max");
	
	inf.readEof();
	
	return 0;
}