import io
import os
import sys

def main():
    MOD = 2147483647
    M = 31
    
    input = io.BytesIO(os.read(0,os.fstat(0).st_size)).readline
    n, q = map(int, input().decode().split())

    hashes = []

    for i in range(n):
        cur_pw = 1
        s = input().decode().rstrip("\r\n")
        hashes.append([0] * len(s))
        cur_hash = 0
        for i, c in enumerate(reversed(s)):
            cur_hash += (ord(c) - 96) * cur_pw
            cur_hash = (cur_hash & MOD) + (cur_hash >> M)
            if cur_hash == MOD:
                cur_hash = 0
            hashes[-1][i] = cur_hash
            cur_pw = cur_pw * M
            cur_pw = (cur_pw & MOD) + (cur_pw >> M)

    for i in range(q):
        u, v, c = map(int, input().decode().split())
        u -= 1
        v -= 1
        sz = min(len(hashes[u]), len(hashes[v]))

        res = 0.5
        pos = c
        first = hashes[u][c] - hashes[v][c] + MOD
        if c:
            first += MOD - hashes[u][c - 1] + hashes[v][c - 1]
        first = (first & MOD) + (first >> M)
        p2 = 1 if first == 0 or first == MOD else 0.5
        for errors in range(0 if first == 0 or first == MOD else 1, 18):
            l = pos
            r = sz
            hvp = hashes[v][pos] - hashes[u][pos] + MOD
            hvp = (hvp & MOD) + (hvp >> M)
            while l + 1 < r:
                m = (l + r) // 2
                h = hashes[u][m] - hashes[v][m] + hvp + MOD
                h = (h & MOD) + (h >> M)
                if h == 0 or h == MOD:
                    l = m
                else:
                    r = m
            res = max(res, (r - c) * p2)
            if r == sz:
                break
            pos = r
            p2 *= 0.5
        
        sys.stdout.write(f'{res:.9f}\n')

main()
