#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	long long n = opt <long long> (1);
	long long k = opt <long long> (2);
	int t = opt <int> (3);
	
	cout << n << ' ';
	
	if (t == 7) {
		cout << n * k << '\n';
		for (int i = 0; i < n; i++)
			cout << k << (i < n - 1 ? ' ' : '\n');
		return 0;
	}
	
	long long sum = 1;
	vector <long long> a(n);
	for (int i = 0; i < n; ++i) {
		a[i] = rnd.next(1ll, k);
		sum += a[i];
	}
	
	if (t == 0) cout << rnd.next(1ll, n * k);
	else if (t == 1) cout << rnd.next(1ll, sum);
	else if (t == 2) cout << rnd.next(sum / 2, sum);
	else if (t == 3) cout << rnd.next(1ll, sum / 2);
	else if (t == 4) cout << rnd.next(1ll, sum / 3);
	else if (t == 5) cout << rnd.next(sum / 3, sum / 3 * 2);
	else if (t == 6) cout << rnd.next(sum / 3 * 2, sum);
	
	cout << '\n';
	for (int i = 0; i < n; i++)
		cout << a[i] << (i < n - 1 ? ' ' : '\n');
	
	return 0;
}