#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n;
	long long R;
	
	cin >> n >> R;
	
	vector <long long> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	
	for (int i = 1; i <= n; i++) {
		if (a[i] > R) {
			cout << "-1\n";
			continue;
		}
		
		int m = max(i - 1, n - i);
		while (m > 0) {
			long long sum = 0;
			for (int j = max(1, i - m); j <= min(n, i + m); j++)
				sum += a[j];
			if (sum <= R) break;
			m--;
		}
		
		cout << m << '\n';
	}
	
	return 0;
}